
/* Common Open Systems Environment, Common Graphics Environment	 */		
/* Extension to	PEX 5.1	version	2.  File date: February	10, 1994 */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN	MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD	TO THIS	      */
/*  SOFTWARE, INCLUDING	ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT	SHALL SUN MICROSYSTEMS,	INC. BE	LIABLE FOR ANY SPECIAL,	      */
/*  INDIRECT OR	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER	RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER	TORTIOUS ACTION, ARISING OUT OF	OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE	OF THIS	SOFTWARE.			      */
/*									      */
/******************************************************************************/


 /* =======================================================================
  * NOTE NOTE NOTE  Insert this	section
  *		    at the end of pl_free.c file
  * ====================================================================='=
  */

/***** Start of	Ext section ************/

#include "PEXExtlib.h"
#include "PEXExtlibint.h"


void PEXExtFreePCAttributes (pcAttr)

INPUT PEXExtPCAttributes	*pcAttr;

{
    CHECK_AND_FREE ((char *) pcAttr->model_clip_volume.half_spaces);
    CHECK_AND_FREE ((char *) pcAttr->light_state.indices);
    CHECK_AND_FREE ((char *) pcAttr->
	tm_resource_hints.prioritized_textures.indices);
    CHECK_AND_FREE ((char *) pcAttr->active_textures.indices);
    CHECK_AND_FREE ((char *) pcAttr->bf_active_textures.indices);

    if (pcAttr->para_surf_char.type == PEXPSCMCLevelCurves ||
	pcAttr->para_surf_char.type == PEXPSCWCLevelCurves)
    {
	CHECK_AND_FREE ((char *)
	    pcAttr->para_surf_char.psc.level_curves.parameters);
    }
    else if (pcAttr->para_surf_char.type == PEXPSCImpDep)
    {
	CHECK_AND_FREE ((char *) pcAttr->para_surf_char.psc.imp_dep.data);
    }

    CHECK_AND_FREE ((char *) pcAttr);
}


void PEXExtFreeRendererAttributes (rdrAttr)

INPUT PEXExtRendererAttributes	*rdrAttr;

{
    CHECK_AND_FREE ((char *) rdrAttr->current_path.elements);
    CHECK_AND_FREE ((char *) rdrAttr->clip_list.rectangles);
    CHECK_AND_FREE ((char *) rdrAttr->pick_start_path.elements);

    CHECK_AND_FREE ((char *) rdrAttr);
}


void PEXExtFreeTableEntries (tableType,	numTableEntries, tableEntries)

INPUT int		tableType;
INPUT unsigned int	numTableEntries;
INPUT PEXPointer	tableEntries;

{
    int		i;
    

    switch (tableType)
    {
    case PEXLUTPattern:
    {
	PEXPatternEntry	*entries = (PEXPatternEntry *) tableEntries;
	
	for (i = 0; i <	numTableEntries; i++)
	    CHECK_AND_FREE ((char *) entries[i].colors.indexed);
	break;
    }
    
    case PEXLUTTextFont:
    {
	PEXTextFontEntry *entries = (PEXTextFontEntry *) tableEntries;
	
	for (i = 0; i <	numTableEntries; i++)
	    CHECK_AND_FREE ((char *) entries[i].fonts);
	break;
    }
    
    case PEXExtLUTTMComposition:
    {
	PEXExtTMCompositionEntry *entries = (PEXExtTMCompositionEntry *) 
	    tableEntries;
	
	for (i = 0; i <	numTableEntries; i++)
	{ 
	    switch (entries[i].method)
	    {
	    case PEXExtTMCompositeReplace:
	    case PEXExtTMCompositeModulate:
	    case PEXExtTMCompositeDecal:
	    case PEXExtTMCompositeBlendEnvColor:
	    case PEXExtTMCompositeDecalBackground:
	    case PEXExtTMCompositeReplaceBlendedColors:
		break;

	    default:
	    {
		CHECK_AND_FREE ((char *) entries[i].data.imp_dep.imp_dep);
	    }
	    }
	} 
	break;
    }

    case PEXLUTLineBundle:
    case PEXLUTMarkerBundle:
    case PEXLUTTextBundle:
    case PEXLUTInteriorBundle:
    case PEXLUTEdgeBundle:
    case PEXLUTColor:
    case PEXLUTView:
    case PEXLUTLight:
    case PEXLUTDepthCue:
    case PEXLUTColorApprox:
    case PEXExtLUTTMBinding:
    case PEXExtLUTTMCoordSource:
    case PEXExtLUTTMSampling:
	break;
    }
}


void PEXExtFreeOCData (count, oc_data)

INPUT unsigned long	count;
INPUT PEXExtOCData	*oc_data;

{
    PEXExtOCData	*oc = oc_data;
    PEXEncodedTextData	*encText;
    PEXListOfVertex	*plset;
    PEXListOfCoord	*fillset;
    PEXListOfCoord2D	*fillset2D;
    PEXListOfVertex	*fillsetdata;
    PEXExtListOfVertex	*extfillsetdata;
    PEXConnectivityData	*pCon;
    PEXListOfTrimCurve	*pTrim;
    int			i, j, k;


    for	(i = 0;	i < count; i++,	oc++)
    {
	switch (oc->oc_type)
	{
	case PEXOCModelClipVolume:

	    CHECK_AND_FREE ((char *) oc->data.SetModelClipVolume.half_spaces);
	    break;

	case PEXOCModelClipVolume2D:

	    CHECK_AND_FREE ((char *) oc->data.SetModelClipVolume2D.half_spaces);
	    break;

	case PEXOCLightSourceState:

	    CHECK_AND_FREE ((char *) oc->data.SetLightSourceState.enable);
	    CHECK_AND_FREE ((char *) oc->data.SetLightSourceState.disable);
	    break;

	case PEXOCParaSurfCharacteristics:

	    if (oc->data.SetParaSurfCharacteristics.psc_type ==
		PEXPSCMCLevelCurves ||
		oc->data.SetParaSurfCharacteristics.psc_type ==
		PEXPSCWCLevelCurves)
		CHECK_AND_FREE ((char *) oc->data.SetParaSurfCharacteristics.characteristics.level_curves.parameters);
	    break;

	case PEXOCAddToNameSet:

	    CHECK_AND_FREE ((char *) oc->data.AddToNameSet.names);
	    break;

	case PEXOCRemoveFromNameSet:

	    CHECK_AND_FREE ((char *) oc->data.RemoveFromNameSet.names);
	    break;

	case PEXOCApplicationData:

	    CHECK_AND_FREE ((char *) oc->data.ApplicationData.data);
	    break;

	case PEXOCGSE:

	    CHECK_AND_FREE ((char *) oc->data.GSE.data);
	    break;

	case PEXOCMarkers:

	    CHECK_AND_FREE ((char *) oc->data.Markers.points);
	    break;

	case PEXOCMarkers2D:

	    CHECK_AND_FREE ((char *) oc->data.Markers2D.points);
	    break;

	case PEXOCPolyline:

	    CHECK_AND_FREE ((char *) oc->data.Polyline.points);
	    break;

	case PEXOCPolyline2D:

	    CHECK_AND_FREE ((char *) oc->data.Polyline2D.points);
	    break;

	case PEXOCText:

	    encText = oc->data.EncodedText.encoded_text;
	    for	(j = 0;	j < oc->data.EncodedText.count;	j++, encText++)
		CHECK_AND_FREE ((char *) encText->ch);
	    CHECK_AND_FREE ((char *) oc->data.EncodedText.encoded_text);
	    break;

	case PEXOCText2D:

	    encText = oc->data.EncodedText2D.encoded_text;
	    for	(j = 0;	j < oc->data.EncodedText2D.count; j++, encText++)
		CHECK_AND_FREE ((char *) encText->ch);
	    CHECK_AND_FREE ((char *) oc->data.EncodedText2D.encoded_text);
	    break;

	case PEXOCAnnotationText:

	    encText = oc->data.EncodedAnnoText.encoded_text;
	    for	(j = 0;	j < oc->data.EncodedAnnoText.count; j++, encText++)
		CHECK_AND_FREE ((char *) encText->ch);
	    CHECK_AND_FREE ((char *) oc->data.EncodedAnnoText.encoded_text);
	    break;

	case PEXOCAnnotationText2D:

	    encText = oc->data.EncodedAnnoText2D.encoded_text;
	    for	(j = 0;	j < oc->data.EncodedAnnoText2D.count; j++, encText++)
		CHECK_AND_FREE ((char *) encText->ch);
	    CHECK_AND_FREE ((char *) oc->data.EncodedAnnoText2D.encoded_text);
	    break;

	case PEXOCPolylineSetWithData:

	    plset = oc->data.PolylineSetWithData.vertex_lists;
	    for	(j = 0;	j < oc->data.PolylineSetWithData.count;	j++, plset++)
	    {
		CHECK_AND_FREE ((char *) plset->vertices.no_data);
	    }
	    CHECK_AND_FREE ((char *) oc->data.PolylineSetWithData.vertex_lists);
	    break;

	case PEXOCNURBCurve:

	    CHECK_AND_FREE ((char *) oc->data.NURBCurve.knots);
	    CHECK_AND_FREE ((char *) oc->data.NURBCurve.points.point);
	    break;

	case PEXOCFillArea:

	    CHECK_AND_FREE ((char *) oc->data.FillArea.points);
	    break;

	case PEXOCFillArea2D:

	    CHECK_AND_FREE ((char *) oc->data.FillArea2D.points);
	    break;

	case PEXOCFillAreaWithData:

	    CHECK_AND_FREE ((char *)
		oc->data.FillAreaWithData.vertices.no_data);
	    break;

	case PEXOCFillAreaSet:

	    fillset = oc->data.FillAreaSet.point_lists;
	    for	(j = 0;	j < oc->data.FillAreaSet.count;	j++, fillset++)
	    {
		CHECK_AND_FREE ((char *) fillset->points);
	    }
	    CHECK_AND_FREE ((char *) oc->data.FillAreaSet.point_lists);
	    break;

	case PEXOCFillAreaSet2D:

	    fillset2D =	oc->data.FillAreaSet2D.point_lists;
	    for	(j = 0;	j < oc->data.FillAreaSet2D.count; j++, fillset2D++)
	    {
		CHECK_AND_FREE ((char *) fillset2D->points);
	    }
	    CHECK_AND_FREE ((char *) oc->data.FillAreaSet2D.point_lists);
	    break;

	case PEXOCFillAreaSetWithData:

	    fillsetdata	= oc->data.FillAreaSetWithData.vertex_lists;
	    for	(j = 0;	j < oc->data.FillAreaSetWithData.count;
		j++, fillsetdata++)
	    {
		CHECK_AND_FREE ((char *) fillsetdata->vertices.no_data);
	    }
	    CHECK_AND_FREE ((char *) oc->data.FillAreaSetWithData.vertex_lists);
	    break;

	case PEXOCTriangleStrip:

	    CHECK_AND_FREE ((char *) oc->data.TriangleStrip.facet_data.index);
	    CHECK_AND_FREE ((char *) oc-> data.TriangleStrip.vertices.no_data);
	    break;

	case PEXOCQuadrilateralMesh:

	    CHECK_AND_FREE ((char *)
		oc->data.QuadrilateralMesh.facet_data.index);
	    CHECK_AND_FREE ((char *)
		oc->data.QuadrilateralMesh.vertices.no_data);
	    break;

	case PEXOCSetOfFillAreaSets:

	    CHECK_AND_FREE ((char *)
		oc->data.SetOfFillAreaSets.facet_data.index);
	    CHECK_AND_FREE ((char *)
		oc->data.SetOfFillAreaSets.vertices.no_data);
	    CHECK_AND_FREE ((char *) oc->data.SetOfFillAreaSets.edge_flags);

	    pCon = oc->data.SetOfFillAreaSets.connectivity;
	    for	(j = 0;	j < oc->data.SetOfFillAreaSets.set_count; j++, pCon++)
	    {
		for (k = 0; k <	(int) pCon->count; k++)
		    CHECK_AND_FREE ((char *) pCon->lists[k].shorts);
		CHECK_AND_FREE ((char *) pCon->lists);
	    }
	    CHECK_AND_FREE ((char *) oc->data.SetOfFillAreaSets.connectivity);
	    break;

	case PEXOCNURBSurface:
	   
	    CHECK_AND_FREE ((char *) oc->data.NURBSurface.uknots);
	    CHECK_AND_FREE ((char *) oc->data.NURBSurface.vknots);
	    CHECK_AND_FREE ((char *) oc->data.NURBSurface.points.point);
	    
	    pTrim = oc->data.NURBSurface.trim_curves;
	    for	(j = 0;	j < oc->data.NURBSurface.curve_count; j++, pTrim++)
	    {
		for (k = 0; k <	(int) pTrim->count; k++)
		{
		    CHECK_AND_FREE ((char *) pTrim->curves[k].knots.floats);
		    CHECK_AND_FREE ((char *)
			pTrim->curves[k].control_points.point);
		}
		CHECK_AND_FREE ((char *) pTrim->curves);
	    }
	    CHECK_AND_FREE ((char *) oc->data.NURBSurface.trim_curves);
	    break;

	case PEXOCCellArray:

	    CHECK_AND_FREE ((char *) oc->data.CellArray.color_indices);
	    break;

	case PEXOCCellArray2D:

	    CHECK_AND_FREE ((char *) oc->data.CellArray2D.color_indices);
	    break;

	case PEXOCExtendedCellArray:

	    CHECK_AND_FREE ((char *) oc->data.ExtendedCellArray.colors.indexed);
	    break;

	case PEXOCGDP:		  

	    CHECK_AND_FREE ((char *) oc->data.GDP.data);
	    break;

	case PEXOCGDP2D:	    

	    CHECK_AND_FREE ((char *) oc->data.GDP2D.data);
	    break;

	case (unsigned short) PEXExtOCActiveTextures:  
	case (unsigned short) PEXExtOCBFActiveTextures:	

	    CHECK_AND_FREE ((char *) oc->data.ExtSetActiveTextures.textures);
	    break;

	case (unsigned short) PEXExtOCTMResourceHints:	

	    CHECK_AND_FREE ((char *) oc->data.ExtSetTMResourceHints.priorities);
	    break;

	case (unsigned short) PEXExtOCFillAreaSetWithData:

	    extfillsetdata = oc->data.ExtFillAreaSetWithData.vertex_lists;
	    for	(j = 0;	j < oc->data.ExtFillAreaSetWithData.count;
		j++, extfillsetdata++)
	    {
		CHECK_AND_FREE ((char *) extfillsetdata->vertices.no_data);
	    }
	    CHECK_AND_FREE ((char *) 
		oc->data.ExtFillAreaSetWithData.vertex_lists);
	    break;

	case (unsigned short) PEXExtOCTriangleStrip:

	    CHECK_AND_FREE ((char *) 
		oc->data.ExtTriangleStrip.facet_data.index);
	    CHECK_AND_FREE ((char *) 
		oc-> data.ExtTriangleStrip.vertices.no_data);
	    break;

	case (unsigned short) PEXExtOCQuadrilateralMesh:

	    CHECK_AND_FREE ((char *)
		oc->data.ExtQuadrilateralMesh.facet_data.index);
	    CHECK_AND_FREE ((char *)
		oc->data.ExtQuadrilateralMesh.vertices.no_data);
	    break;

	case (unsigned short) PEXExtOCSetOfFillAreaSets:

	    CHECK_AND_FREE ((char *)
		oc->data.ExtSetOfFillAreaSets.facet_data.index);
	    CHECK_AND_FREE ((char *)
		oc->data.ExtSetOfFillAreaSets.vertices.no_data);
	    CHECK_AND_FREE ((char *) oc->data.ExtSetOfFillAreaSets.edge_flags);

	    pCon = oc->data.ExtSetOfFillAreaSets.connectivity;
	    for	(j = 0;	j < oc->data.ExtSetOfFillAreaSets.set_count; 
		 j++, pCon++)
	    {
		for (k = 0; k <	(int) pCon->count; k++)
		    CHECK_AND_FREE ((char *) pCon->lists[k].shorts);
		CHECK_AND_FREE ((char *) pCon->lists);
	    }
	    CHECK_AND_FREE ((char *) 
		oc->data.ExtSetOfFillAreaSets.connectivity);
	    break;

	default:	    

	    CHECK_AND_FREE ((char *) oc->data.ExtVendorExtOC.data);
	    break;

	}
    }

    CHECK_AND_FREE ((char *) oc_data);
}

/***** End of Ext section ************/
