
/* Common Open Systems Environment, Common Graphics Environment	 */		
/* Extension to	PEX 5.1	version	2.  File date: February	10, 1994 */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN	MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD	TO THIS	      */
/*  SOFTWARE, INCLUDING	ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT	SHALL SUN MICROSYSTEMS,	INC. BE	LIABLE FOR ANY SPECIAL,	      */
/*  INDIRECT OR	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER	RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER	TORTIOUS ACTION, ARISING OUT OF	OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE	OF THIS	SOFTWARE.			      */
/*									      */
/******************************************************************************/


 /* =======================================================================
  * NOTE NOTE NOTE  Insert this	section
  *		    at the end of pl_oc_attr.c file
  * ====================================================================='=
  */

/***** Start of	Ext section *************/

#include "PEXExtlib.h"
#include "PEXExtlibint.h"


void
PEXExtSetTMPerspectiveCorrection (display, resource_id,	req_type, method)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT int		method;

{
    register pexExtTMPerspectiveCorrection	*req;

    BEGIN_SIMPLE_OC (ExtTMPerspectiveCorrection, resource_id, req_type,	req);
    req->correction = method;
    END_SIMPLE_OC (ExtTMPerspectiveCorrection, resource_id, req_type, req);
}


void
PEXExtSetTMSampleFrequency (display, resource_id, req_type, frequency)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT int		frequency;

{
    register pexExtTMSampleFrequency	*req;

    BEGIN_SIMPLE_OC (ExtTMSampleFrequency, resource_id,	req_type, req);
    req->sampleFrequency = frequency;
    END_SIMPLE_OC (ExtTMSampleFrequency, resource_id,	req_type, req);
}


void
PEXExtSetTMResourceHints (display, resource_id,	req_type,
    optimization_hint, count, priorities)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT int		optimization_hint;
INPUT unsigned int	count;
INPUT PEXTableIndex	*priorities;

{
    register pexExtTMResourceHints	*req;
    char				*pBuf;
    int					dataLength;

    /*
     * Initialize the OC request.
     */

    dataLength = NUMWORDS (count * SIZEOF (CARD16));

    PEXInitOC (display,	resource_id, req_type,
	LENOF (pexExtTMResourceHints), dataLength, pBuf);

    if (pBuf ==	NULL) return;


    /* 
     * Store the request header	data. 
     */

    BEGIN_OC_HEADER (ExtTMResourceHints, dataLength, pBuf, req);

    req->optimization =	optimization_hint;
    req->numIndex = count;

    END_OC_HEADER (ExtTMResourceHints, pBuf, req);


    /*
     * Copy the	oc data.
     */

    OC_LISTOF_CARD16_PAD (count, priorities);

    PEXFinishOC	(display);
    PEXSyncHandle (display);
}


void
PEXExtSetActiveTextures	(display, resource_id, req_type,
    count, textures)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT unsigned int	count;
INPUT PEXTableIndex	*textures;

{
    register pexExtActiveTextures	*req;
    char				*pBuf;
    int					dataLength;

    /*
     * Initialize the OC request.
     */

    dataLength = NUMWORDS (count * SIZEOF (CARD16));

    PEXInitOC (display,	resource_id, req_type,
	LENOF (pexExtActiveTextures), dataLength, pBuf);

    if (pBuf ==	NULL) return;


    /* 
     * Store the request header	data. 
     */

    BEGIN_OC_HEADER (ExtActiveTextures,	dataLength, pBuf, req);

    req->numIndex = count;

    END_OC_HEADER (ExtActiveTextures, pBuf, req);


    /*
     * Copy the	oc data.
     */

    OC_LISTOF_CARD16_PAD (count, textures);

    PEXFinishOC	(display);
    PEXSyncHandle (display);
}


void
PEXExtSetBFActiveTextures (display, resource_id, req_type,
    count, textures)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT unsigned int	count;
INPUT PEXTableIndex	*textures;

{
    register pexExtBFActiveTextures	*req;
    char				*pBuf;
    int					dataLength;

    /*
     * Initialize the OC request.
     */

    dataLength = NUMWORDS (count * SIZEOF (CARD16));

    PEXInitOC (display,	resource_id, req_type,
	LENOF (pexExtBFActiveTextures),	dataLength, pBuf);

    if (pBuf ==	NULL) return;


    /* 
     * Store the request header	data. 
     */

    BEGIN_OC_HEADER (ExtBFActiveTextures, dataLength, pBuf, req);

    req->numIndex = count;

    END_OC_HEADER (ExtBFActiveTextures,	pBuf, req);


    /*
     * Copy the	oc data.
     */

    OC_LISTOF_CARD16_PAD (count, textures);

    PEXFinishOC	(display);
    PEXSyncHandle (display);
}



void
PEXExtSetPrimitiveAA (display, resource_id, req_type, mode, blend_op)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT int		mode;
INPUT int		blend_op;

{
    register pexExtPrimitiveAA	*req;

    BEGIN_SIMPLE_OC (ExtPrimitiveAA, resource_id, req_type, req);
    req->mode =	mode;
    req->blend_op = blend_op;
    END_SIMPLE_OC (ExtPrimitiveAA, resource_id,	req_type, req);
}


void
PEXExtSetLineCapStyle (display,	resource_id, req_type, style)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT int		style;

{
    register pexExtLineCap	*req;

    BEGIN_SIMPLE_OC (ExtLineCap, resource_id, req_type,	req);
    req->style = style;
    END_SIMPLE_OC (ExtLineCap, resource_id, req_type, req);
}


void
PEXExtSetLineJoinStyle (display, resource_id, req_type,	style)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT int		style;

{
    register pexExtLineJoin	*req;

    BEGIN_SIMPLE_OC (ExtLineJoin, resource_id, req_type, req);
    req->style = style;
    END_SIMPLE_OC (ExtLineJoin,	resource_id, req_type, req);
}
/***** End of Ext section ************/
